<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import {
  Agenda,
  CityHero,
  ConductBanner,
  Sponsor,
  WorldTourForm,
  WorldTourFormMulti,
} from '../../../components/events/world-tour/index.vue';
import { getPageMetadata } from '~/common/meta';
import { FooterEditLinkMixin } from '~/mixins';
import { WorldTourEventsService } from '~/services';

export default Vue.extend({
  components: {
    CityHero,
    ConductBanner,
    Agenda,
    WorldTourFormMulti,
    Sponsor,
    WorldTourForm,
  },
  mixins: [FooterEditLinkMixin],
  nuxtI18n: false,
  async asyncData({ params, $worldTourEventsService }: any) {
    try {
      const eventSlug = params.city;
      const { city, spaceId, entryId } = await (
        $worldTourEventsService as WorldTourEventsService
      ).getWorldTourEvent(eventSlug);

      return { city, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata((this as any).city.metadata, this.$route.path),
    };
  },
});
</script>

<template>
  <div class="events-connect">
    <CityHero
      v-if="city.hero"
      v-bind="city.hero"
      :registration-closed="city.form?.registrationClosed"
      :location="city.location"
      :date="city.date"
      class="events-connect__hero"
    />
    <Agenda
      v-if="city.agenda"
      v-bind="city.agenda"
      :registration-closed="city.form?.registrationClosed"
      :location="city.location"
    />
    <WorldTourFormMulti
      v-if="city.form && city.form.multiStepForm"
      v-bind="city.form"
    />
    <div class="events-connect__sponsors">
      <Sponsor v-if="city.sponsors" v-bind="city.sponsors[0]" />
    </div>
    <WorldTourForm
      v-if="city.form && !city.form.multiStepForm"
      connect-variant
      v-bind="city.form"
    />

    <div v-if="city.footnote">
      <ConductBanner
        v-for="footnote in city.footnote"
        :key="footnote.header"
        v-bind="footnote"
        class="city__section"
      />
    </div>
  </div>
</template>
<style lang="scss" scoped>
.city {
  &__section {
    & + .city__section {
      padding-top: 0;
    }
  }
}
.events-connect {
  &__hero#hero-container {
    background: url('/nuxt-images/events/connect/city-hero-connect.png');
    margin-bottom: 64px;
    background-repeat: no-repeat;
    background-size: auto 125%;
    @media (min-width: $breakpoint-md) {
      margin-bottom: 160px;
    }

    :deep {
      .hero-wrapper {
        margin: 0;
      }
      .hero-text {
        padding: 70px 0;
        @media (min-width: $breakpoint-md) {
          padding: 120px 0;
        }
      }
    }
  }
  :deep {
    .agenda-cta {
      background: $color-surface-900;
      box-shadow: none;
      color: $color-text-300;
      z-index: 1;
    }
    .agenda-event {
      background: $color-surface-800;
      color: $color-text-300;
      cursor: default;
      &.agenda-event__accordion {
        cursor: pointer;
        .slp-icon.plus-icon.mobile {
          display: block !important;
        }
        &.open {
          .speaker {
            margin-top: 0;
            ~ .speaker {
              @media (min-width: $breakpoint-md) {
                margin-top: 64px !important;
              }
            }
          }
        }
        .slp-icon.plus-icon {
          @media (min-width: $breakpoint-md) {
            display: block;
            position: absolute;
            right: 24px;
            top: 24px;
          }
        }
      }

      .information.information--w-speakers {
        position: relative;
        @media (min-width: $breakpoint-md) {
          display: block;
          column-count: 2;
          gap: 16px;
        }
        .speaker {
          break-before: column;
          margin-top: 16px;
          @media (min-width: $breakpoint-md) {
            margin-top: 0;
          }
          ~ .speaker {
            break-before: auto;
            margin-top: 0;
            @media (min-width: $breakpoint-md) {
              margin-top: 32px;
            }
          }
          @media (min-width: $breakpoint-md) {
            margin-right: 16px;
          }
        }
      }
      .information:not(.information--w-speakers) {
        display: block !important;
        position: relative;
      }
      .description {
        margin-top: 32px;
        padding: 0 16px;
        @media (min-width: $breakpoint-md) {
          padding: 32px;
          margin-right: 32px;
          margin-top: 0;
        }
      }
      .slp-icon.plus-icon.mobile {
        display: none !important;
      }
    }
    .agenda-event:nth-child(odd) {
      background-color: $color-surface-900;
      color: $color-text-300;
    }
    .agenda-container {
      background-color: $color-text-50;
    }
    .form-wrapper {
      background-color: $color-text-300;
    }
    .conduct-wrapper.city__section {
      background: $color-surface-900;
      color: $color-text-300;
      .text a {
        color: $color-text-300 !important;
      }
    }
    .agenda-header {
      .header {
        &::before {
          display: none;
        }
      }
    }
  }
  &__sponsors {
    background: $color-surface-900;
    padding: 80px 0;
    @media (min-width: $breakpoint-md) {
      padding: 120px 0;
    }
    .sponsor {
      margin: 0 auto;
    }
    :deep {
      .slp-row {
        display: block;
      }
      .flex {
        display: grid;
        width: 100%;
        grid-template-columns: repeat(2, 1fr);
        gap: 32px;

        @media (min-width: $breakpoint-md) {
          grid-template-columns: repeat(4, 1fr);
        }
      }
      .imgs-container {
        margin-top: 24px;
        padding: 24px 0;
      }
      .header.slp-text-heading5 {
        margin-top: 24px;
      }
    }
  }
}
</style>
